=== libs/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

configure_file(
  core/src/ecflow/core/ecflow_version.h.in
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_version.h)
configure_file(
  core/src/ecflow/core/ecflow_source_build_dir.h.in
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_source_build_dir.h)

set(srcs
  # Attribute -- Headers
  attribute/src/ecflow/attribute/AutoArchiveAttr.hpp
  attribute/src/ecflow/attribute/AutoCancelAttr.hpp
  attribute/src/ecflow/attribute/ClockAttr.hpp
  attribute/src/ecflow/attribute/CronAttr.hpp
  attribute/src/ecflow/attribute/DateAttr.hpp
  attribute/src/ecflow/attribute/DayAttr.hpp
  attribute/src/ecflow/attribute/GenericAttr.hpp
  attribute/src/ecflow/attribute/LateAttr.hpp
  attribute/src/ecflow/attribute/NodeAttr.hpp
  attribute/src/ecflow/attribute/QueueAttr.hpp
  attribute/src/ecflow/attribute/RepeatAttr.hpp
  attribute/src/ecflow/attribute/RepeatRange.hpp
  attribute/src/ecflow/attribute/TimeAttr.hpp
  attribute/src/ecflow/attribute/TodayAttr.hpp
  attribute/src/ecflow/attribute/Variable.hpp
  attribute/src/ecflow/attribute/VerifyAttr.hpp
  attribute/src/ecflow/attribute/Zombie.hpp
  attribute/src/ecflow/attribute/ZombieAttr.hpp
  # Attribute -- Sources
  attribute/src/ecflow/attribute/AutoArchiveAttr.cpp
  attribute/src/ecflow/attribute/AutoCancelAttr.cpp
  attribute/src/ecflow/attribute/ClockAttr.cpp
  attribute/src/ecflow/attribute/CronAttr.cpp
  attribute/src/ecflow/attribute/DateAttr.cpp
  attribute/src/ecflow/attribute/DayAttr.cpp
  attribute/src/ecflow/attribute/GenericAttr.cpp
  attribute/src/ecflow/attribute/LateAttr.cpp
  attribute/src/ecflow/attribute/NodeAttr.cpp
  attribute/src/ecflow/attribute/QueueAttr.cpp
  attribute/src/ecflow/attribute/RepeatAttr.cpp
  attribute/src/ecflow/attribute/TimeAttr.cpp
  attribute/src/ecflow/attribute/TodayAttr.cpp
  attribute/src/ecflow/attribute/Variable.cpp
  attribute/src/ecflow/attribute/VerifyAttr.cpp
  attribute/src/ecflow/attribute/Zombie.cpp
  attribute/src/ecflow/attribute/ZombieAttr.cpp

  # Base -- Headers
  base/src/ecflow/base/AbstractClientEnv.hpp
  base/src/ecflow/base/AbstractServer.hpp
  base/src/ecflow/base/Client.hpp
  base/src/ecflow/base/ClientOptionsParser.hpp
  base/src/ecflow/base/ClientToServerRequest.hpp
  base/src/ecflow/base/Cmd.hpp
  base/src/ecflow/base/Connection.hpp
  base/src/ecflow/base/Gnuplot.hpp
  base/src/ecflow/base/ServerReply.hpp
  base/src/ecflow/base/ServerToClientResponse.hpp
  base/src/ecflow/base/Stats.hpp
  base/src/ecflow/base/WhyCmd.hpp
  base/src/ecflow/base/ZombieCtrl.hpp
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/Openssl.hpp>
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/ssl_connection.hpp>
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/SslClient.hpp>
  base/src/ecflow/base/cts/ClientToServerCmd.hpp
  base/src/ecflow/base/cts/CtsCmdRegistry.hpp
  base/src/ecflow/base/cts/EditHistoryMgr.hpp
  base/src/ecflow/base/cts/task/AbortCmd.hpp
  base/src/ecflow/base/cts/task/CompleteCmd.hpp
  base/src/ecflow/base/cts/task/CtsWaitCmd.hpp
  base/src/ecflow/base/cts/task/EventCmd.hpp
  base/src/ecflow/base/cts/task/InitCmd.hpp
  base/src/ecflow/base/cts/task/LabelCmd.hpp
  base/src/ecflow/base/cts/task/MeterCmd.hpp
  base/src/ecflow/base/cts/task/QueueCmd.hpp
  base/src/ecflow/base/cts/task/TaskApi.hpp
  base/src/ecflow/base/cts/task/TaskCmd.hpp
  base/src/ecflow/base/cts/user/AlterCmd.hpp
  base/src/ecflow/base/cts/user/BeginCmd.hpp
  base/src/ecflow/base/cts/user/CFileCmd.hpp
  base/src/ecflow/base/cts/user/CheckPtCmd.hpp
  base/src/ecflow/base/cts/user/ClientHandleCmd.hpp
  base/src/ecflow/base/cts/user/CSyncCmd.hpp
  base/src/ecflow/base/cts/user/CtsApi.hpp
  base/src/ecflow/base/cts/user/CtsCmd.hpp
  base/src/ecflow/base/cts/user/CtsNodeCmd.hpp
  base/src/ecflow/base/cts/user/DeleteCmd.hpp
  base/src/ecflow/base/cts/user/EditScriptCmd.hpp
  base/src/ecflow/base/cts/user/ForceCmd.hpp
  base/src/ecflow/base/cts/user/FreeDepCmd.hpp
  base/src/ecflow/base/cts/user/GroupCTSCmd.hpp
  base/src/ecflow/base/cts/user/LoadDefsCmd.hpp
  base/src/ecflow/base/cts/user/LogCmd.hpp
  base/src/ecflow/base/cts/user/LogMessageCmd.hpp
  base/src/ecflow/base/cts/user/MoveCmd.hpp
  base/src/ecflow/base/cts/user/OrderNodeCmd.hpp
  base/src/ecflow/base/cts/user/PathsCmd.hpp
  base/src/ecflow/base/cts/user/PlugCmd.hpp
  base/src/ecflow/base/cts/user/QueryCmd.hpp
  base/src/ecflow/base/cts/user/ReplaceNodeCmd.hpp
  base/src/ecflow/base/cts/user/RequeueNodeCmd.hpp
  base/src/ecflow/base/cts/user/RunNodeCmd.hpp
  base/src/ecflow/base/cts/user/ServerVersionCmd.hpp
  base/src/ecflow/base/cts/user/ShowCmd.hpp
  base/src/ecflow/base/cts/user/UserCmd.hpp
  base/src/ecflow/base/cts/user/ZombieCmd.hpp
  base/src/ecflow/base/stc/BlockClientZombieCmd.hpp
  base/src/ecflow/base/stc/DefsCache.hpp
  base/src/ecflow/base/stc/DefsCmd.hpp
  base/src/ecflow/base/stc/ErrorCmd.hpp
  base/src/ecflow/base/stc/GroupSTCCmd.hpp
  base/src/ecflow/base/stc/PreAllocatedReply.hpp
  base/src/ecflow/base/stc/SClientHandleCmd.hpp
  base/src/ecflow/base/stc/SClientHandleSuitesCmd.hpp
  base/src/ecflow/base/stc/SNewsCmd.hpp
  base/src/ecflow/base/stc/SNodeCmd.hpp
  base/src/ecflow/base/stc/SServerLoadCmd.hpp
  base/src/ecflow/base/stc/SStatsCmd.hpp
  base/src/ecflow/base/stc/SStringCmd.hpp
  base/src/ecflow/base/stc/SStringVecCmd.hpp
  base/src/ecflow/base/stc/SSuitesCmd.hpp
  base/src/ecflow/base/stc/SSyncCmd.hpp
  base/src/ecflow/base/stc/ServerToClientCmd.hpp
  base/src/ecflow/base/stc/StcCmd.hpp
  base/src/ecflow/base/stc/ZombieGetCmd.hpp
  # Base -- Sources
  base/src/ecflow/base/Client.cpp
  base/src/ecflow/base/ClientOptionsParser.cpp
  base/src/ecflow/base/ClientToServerRequest.cpp
  base/src/ecflow/base/Connection.cpp
  base/src/ecflow/base/Gnuplot.cpp
  base/src/ecflow/base/ServerReply.cpp
  base/src/ecflow/base/ServerToClientResponse.cpp
  base/src/ecflow/base/Stats.cpp
  base/src/ecflow/base/WhyCmd.cpp
  base/src/ecflow/base/ZombieCtrl.cpp
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/Openssl.cpp>
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/ssl_connection.cpp>
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/SslClient.cpp>
  base/src/ecflow/base/cts/ClientToServerCmd.cpp
  base/src/ecflow/base/cts/CtsCmdRegistry.cpp
  base/src/ecflow/base/cts/EditHistoryMgr.cpp
  base/src/ecflow/base/cts/task/AbortCmd.cpp
  base/src/ecflow/base/cts/task/CompleteCmd.cpp
  base/src/ecflow/base/cts/task/CtsWaitCmd.cpp
  base/src/ecflow/base/cts/task/EventCmd.cpp
  base/src/ecflow/base/cts/task/InitCmd.cpp
  base/src/ecflow/base/cts/task/LabelCmd.cpp
  base/src/ecflow/base/cts/task/MeterCmd.cpp
  base/src/ecflow/base/cts/task/QueueCmd.cpp
  base/src/ecflow/base/cts/task/TaskApi.cpp
  base/src/ecflow/base/cts/task/TaskCmd.cpp
  base/src/ecflow/base/cts/user/AlterCmd.cpp
  base/src/ecflow/base/cts/user/BeginCmd.cpp
  base/src/ecflow/base/cts/user/CFileCmd.cpp
  base/src/ecflow/base/cts/user/CSyncCmd.cpp
  base/src/ecflow/base/cts/user/CheckPtCmd.cpp
  base/src/ecflow/base/cts/user/ClientHandleCmd.cpp
  base/src/ecflow/base/cts/user/CtsApi.cpp
  base/src/ecflow/base/cts/user/CtsCmd.cpp
  base/src/ecflow/base/cts/user/CtsNodeCmd.cpp
  base/src/ecflow/base/cts/user/DeleteCmd.cpp
  base/src/ecflow/base/cts/user/EditScriptCmd.cpp
  base/src/ecflow/base/cts/user/ForceCmd.cpp
  base/src/ecflow/base/cts/user/FreeDepCmd.cpp
  base/src/ecflow/base/cts/user/GroupCTSCmd.cpp
  base/src/ecflow/base/cts/user/LoadDefsCmd.cpp
  base/src/ecflow/base/cts/user/LogCmd.cpp
  base/src/ecflow/base/cts/user/LogMessageCmd.cpp
  base/src/ecflow/base/cts/user/MoveCmd.cpp
  base/src/ecflow/base/cts/user/OrderNodeCmd.cpp
  base/src/ecflow/base/cts/user/PathsCmd.cpp
  base/src/ecflow/base/cts/user/PlugCmd.cpp
  base/src/ecflow/base/cts/user/QueryCmd.cpp
  base/src/ecflow/base/cts/user/ReplaceNodeCmd.cpp
  base/src/ecflow/base/cts/user/RequeueNodeCmd.cpp
  base/src/ecflow/base/cts/user/RunNodeCmd.cpp
  base/src/ecflow/base/cts/user/ServerVersionCmd.cpp
  base/src/ecflow/base/cts/user/ShowCmd.cpp
  base/src/ecflow/base/cts/user/UserCmd.cpp
  base/src/ecflow/base/cts/user/ZombieCmd.cpp
  base/src/ecflow/base/stc/BlockClientZombieCmd.cpp
  base/src/ecflow/base/stc/DefsCache.cpp
  base/src/ecflow/base/stc/DefsCmd.cpp
  base/src/ecflow/base/stc/ErrorCmd.cpp
  base/src/ecflow/base/stc/GroupSTCCmd.cpp
  base/src/ecflow/base/stc/PreAllocatedReply.cpp
  base/src/ecflow/base/stc/SClientHandleCmd.cpp
  base/src/ecflow/base/stc/SClientHandleSuitesCmd.cpp
  base/src/ecflow/base/stc/SNewsCmd.cpp
  base/src/ecflow/base/stc/SNodeCmd.cpp
  base/src/ecflow/base/stc/SServerLoadCmd.cpp
  base/src/ecflow/base/stc/SStatsCmd.cpp
  base/src/ecflow/base/stc/SStringCmd.cpp
  base/src/ecflow/base/stc/SStringVecCmd.cpp
  base/src/ecflow/base/stc/SSuitesCmd.cpp
  base/src/ecflow/base/stc/SSyncCmd.cpp
  base/src/ecflow/base/stc/ServerToClientCmd.cpp
  base/src/ecflow/base/stc/StcCmd.cpp
  base/src/ecflow/base/stc/ZombieGetCmd.cpp

  # Client -- Headers
  client/src/ecflow/client/ClientCmdCache.hpp
  client/src/ecflow/client/ClientEnvironment.hpp
  client/src/ecflow/client/ClientInvoker.hpp
  client/src/ecflow/client/ClientOptions.hpp
  client/src/ecflow/client/Help.hpp
  client/src/ecflow/client/Rtt.hpp
  client/src/ecflow/client/UrlCmd.hpp
  # Client -- Sources
  client/src/ecflow/client/ClientCmdCache.cpp
  client/src/ecflow/client/Rtt.cpp
  client/src/ecflow/client/ClientEnvironment.cpp
  client/src/ecflow/client/ClientInvoker.cpp
  client/src/ecflow/client/Help.cpp
  client/src/ecflow/client/Rtt.cpp
  client/src/ecflow/client/ClientOptions.cpp
  client/src/ecflow/client/UrlCmd.cpp

  # Core -- Headers
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_version.h
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_source_build_dir.h
  core/src/ecflow/core/AssertTimer.hpp
  core/src/ecflow/core/Cal.hpp
  core/src/ecflow/core/Calendar.hpp
  core/src/ecflow/core/CalendarUpdateParams.hpp
  core/src/ecflow/core/CheckPt.hpp
  core/src/ecflow/core/Child.hpp
  core/src/ecflow/core/Chrono.hpp
  core/src/ecflow/core/CommandLine.hpp
  core/src/ecflow/core/DState.hpp
  core/src/ecflow/core/DebugPerf.hpp
  core/src/ecflow/core/DurationTimer.hpp
  core/src/ecflow/core/Ecf.hpp
  core/src/ecflow/core/EcfPortLock.hpp
  core/src/ecflow/core/Extract.hpp
  core/src/ecflow/core/File.hpp
  core/src/ecflow/core/File_r.hpp
  core/src/ecflow/core/Filesystem.hpp
  core/src/ecflow/core/Host.hpp
  core/src/ecflow/core/Indentor.hpp
  core/src/ecflow/core/Log.hpp
  core/src/ecflow/core/LogVerification.hpp
  core/src/ecflow/core/Message.hpp
  core/src/ecflow/core/NOrder.hpp
  core/src/ecflow/core/NState.hpp
  core/src/ecflow/core/NodePath.hpp
  core/src/ecflow/core/Overload.hpp
  core/src/ecflow/core/Passwd.hpp
  core/src/ecflow/core/PasswdFile.hpp
  core/src/ecflow/core/PasswordEncryption.hpp
  core/src/ecflow/core/Pid.hpp
  core/src/ecflow/core/PrintStyle.hpp
  core/src/ecflow/core/SState.hpp
  core/src/ecflow/core/Serialization.hpp
  core/src/ecflow/core/Stl.hpp
  core/src/ecflow/core/Str.hpp
  core/src/ecflow/core/StringSplitter.hpp
  core/src/ecflow/core/TimeSeries.hpp
  core/src/ecflow/core/TimeSlot.hpp
  core/src/ecflow/core/TimeStamp.hpp
  core/src/ecflow/core/User.hpp
  core/src/ecflow/core/Version.hpp
  core/src/ecflow/core/WhiteListFile.hpp
  core/src/ecflow/core/cereal_boost_time.hpp
  core/src/ecflow/core/cereal_optional_nvp.hpp
  core/src/ecflow/core/perf_timer.hpp
  core/src/ecflow/core/exceptions/Exceptions.hpp
  # Core -- Sources
  core/src/ecflow/core/AssertTimer.cpp
  core/src/ecflow/core/Cal.cpp
  core/src/ecflow/core/Calendar.cpp
  core/src/ecflow/core/Child.cpp
  core/src/ecflow/core/Chrono.cpp
