=== docs/build_python_api/requirements.txt ===
# These are the requirements for readthedoc
docutils<=0.16.0
Sphinx>=4.4.0
setuptools>=51.0.0
sphinx-rtd-theme>=0.5.0
pyyaml
