=== debian/changelog ===
ecflow (5.13.7-1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 22:03:54 +0000

ecflow (5.13.7-1) unstable; urgency=medium

  * Drop B-D on dh-buildinfo
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 08 Feb 2025 05:18:38 +0000
